<%@
page import="
java.util.*,
ca.ubc.cs.beta.hal.utils.Global,
java.util.logging.*,
ca.ubc.cs.beta.hal.utils.*,
java.text.SimpleDateFormat,
java.util.Calendar,
java.net.URLEncoder"
%>
<%
long pagenum=1;
long offset = 0;
int limit=10;
long numRecordsCount = 0;

long maxPage = 1;

// define defaults for all filterables
Level infoLevel = Level.ALL;
String hostname = null;
String time = null;
Date before = null;
Date after = null;

String queryString = "";

int limits[] = {10,25,50,100};
boolean autorefresh = false;

String outputDateFormat = "MMM dd, yyyy HH:mm:ss";
SimpleDateFormat dateOutput = new SimpleDateFormat(outputDateFormat);

String hostCols     = "2";
String levelCols    = "1";
String timeCols     = "2";
String messageCols  = "7";

List<Pair<String,LogRecord>> logs;

Map<String,String[]> paramMap = (Map<String,String[]>) request.getParameterMap();

if (paramMap.containsKey("page")) {
	pagenum = Integer.parseInt(paramMap.get("page")[0]);
	if (pagenum < 1) { Global.getBaseLogger().warning("getLogs.jsp: Invalid page parameter: "+pagenum+". Setting pagenum to 1."); pagenum = 1; }
}

if (paramMap.containsKey("limit")) {
	limit = Integer.parseInt(paramMap.get("limit")[0]);
	if (limit < 1) { Global.getBaseLogger().warning("getLogs.jsp: Invalid limit parameter: "+limit+". Setting limit to 10."); limit=10; }
}

if (paramMap.containsKey("autorefresh")) {
	autorefresh = Boolean.parseBoolean(paramMap.get("autorefresh")[0]);
}

// moved numRecordsCount SQL queries here because we need to know
// this number so that we can properly calculate offset in case
// we're at a boundary condition.

if (paramMap.containsKey("level")) {
	infoLevel = Level.parse(paramMap.get("level")[0]);
	numRecordsCount = Global.getDataManager().getFilteredLogRecordsByLevelCount(infoLevel);
} else if (paramMap.containsKey("hostname")) {
	hostname = paramMap.get("hostname")[0];
	numRecordsCount = Global.getDataManager().getFilteredLogRecordsByHostnameCount(hostname);
} else if (paramMap.containsKey("time")) {
	time = paramMap.get("time")[0];
	
	if (time.equals("int")) {  
		String format = "yyyy-MM-dd HH:mm"; // Change me!
		SimpleDateFormat df = new SimpleDateFormat(format);
		String beforeString = paramMap.get("before")[0];
		String afterString  = paramMap.get("after")[0];
		before = df.parse(beforeString);
		after  = df.parse(afterString);	
	} else {
		Calendar cal = Calendar.getInstance();
		after = cal.getTime();
		
		if (time.equals("5min")) { cal.add(Calendar.MINUTE,-5); }
		else if (time.equals("10min")) { cal.add(Calendar.MINUTE,-10); }
		else if (time.equals("30min")) { cal.add(Calendar.MINUTE,-30); }
		//else if (time.equals("1day"))  { cal.add(Calendar.DAY_OF_YEAR,-1); }
		else { 
			Global.getBaseLogger().warning("getLogs.jsp: Invalid time parameter: "+time+". Setting interval to 5minutes.");
			cal.add(Calendar.MINUTE,-5);
		}
		
		before = cal.getTime();
	}
	numRecordsCount = Global.getDataManager().getFilteredLogRecordsByTimeCount(before, after);	
} else {
	numRecordsCount = Global.getDataManager().getLogRecordsCount();
}

if (paramMap.containsKey("autorefresh")) {
    autorefresh = Boolean.parseBoolean(paramMap.get("autorefresh")[0]);
}

//handle maxPage edge cases

if (numRecordsCount < 1) {
	maxPage = 1;
} else if (numRecordsCount % limit == 0) {
    maxPage = (numRecordsCount/limit);
} else {
    maxPage = (int)Math.ceil(numRecordsCount/(double)limit);
}

if (pagenum > maxPage) { pagenum = maxPage; }
offset = (pagenum-1)*limit;

if (infoLevel != Level.ALL) {
	logs = Global.getDataManager().getFilteredLogRecordsByLevel(infoLevel, limit, offset);	
} else if (hostname != null) {
	logs = Global.getDataManager().getFilteredLogRecordsByHostname(hostname, limit, offset);
} else if (time != null) {
	logs = Global.getDataManager().getFilteredLogRecordsByTime(before,after,limit,offset);
} else {
	logs = Global.getDataManager().getLogRecords(limit,offset);	
}
%>

<%
//System.out.println("There are "+numRecordsCount+" logs");

Enumeration en = request.getParameterNames();
while(en.hasMoreElements()) {
	String paramName = (String)en.nextElement();
	String paramVal  = request.getParameter(paramName);
	
	if (paramName.equals("page") || paramName.equals("limit") || paramName.equals("autorefresh")) continue;
	
	if (queryString.equals("")) {
		queryString = queryString + "?" + paramName + "=" + URLEncoder.encode(paramVal,"UTF-8");
	} else {
		queryString = queryString + "&" + paramName + "=" + URLEncoder.encode(paramVal,"UTF-8");
	}
}

if (queryString.equals("")) { queryString = "?"; }
//System.out.println("QueryString: "+queryString);
%>

<div id="logsTable">
<!-- ---------- PAGINATION SECTION ---------- -->
<div id="logsTableNav center" class="pagination">
<!-- ------------ PAGES SECTION ------------- -->
<ul id="pageNavigation">
    <li><a name="1" id="firstPageLink" class="log" href="/jsp/getLogs.jsp<%= queryString %>&limit=<%= limit %>">&lt;&lt;</a></li>
    
    <%
    long lowerPageBound = pagenum-2;
    long upperPageBound = pagenum+2;
    
    if (lowerPageBound<1) { lowerPageBound=1; upperPageBound=5; }
    else if (upperPageBound>maxPage) { lowerPageBound=maxPage-4; upperPageBound=maxPage; }
    if (maxPage<5) { lowerPageBound=1; upperPageBound=maxPage; }
    %>
    
    <% if (pagenum==1) {  %>
    <li><a name="1" class="log" href="/jsp/getLogs.jsp<%= queryString %>&limit=<%= limit %>">&lt;</a></li>
    <% } else { %>
    <li><a name="<%= pagenum-1 %>" class="log" href="/jsp/getLogs.jsp<%= queryString %>&page=<%= pagenum-1 %>&limit=<%= limit %>">&lt;</a></li>
    <% } %>
    
    <% for(long i=lowerPageBound; i<= upperPageBound; i++) { %>
    <li<% if (pagenum==i) { %> class="active disabled"<% } %>><a name="<%= i %>" class="log" href="/jsp/getLogs.jsp<%= queryString %>&page=<%= i %>&limit=<%= limit %>"><%= i %></a></li>
    <% } %>
    
    <% if (pagenum == maxPage) { %>
    <li><a name="<%= maxPage %>" class="log" href="/jsp/getLogs.jsp<%= queryString %>&page=<%= maxPage %>&limit=<%= limit %>">&gt;</a></li>
    <% } else { %>
    <li><a name="<%= pagenum+1 %>" class="log" href="/jsp/getLogs.jsp<%= queryString %>&page=<%= pagenum+1 %>&limit=<%= limit %>">&gt;</a></li>
    <% } %>
    
    <li><a name="<%= maxPage %>" id="maxPageLink" class="log" href="/jsp/getLogs.jsp<%= queryString %>&page=<%= maxPage %>&limit=<%= limit %>">&gt;&gt;</a></li>
</ul>

<!-- ---------- LIMIT SECTION ---------- -->
<ul id="limitNavigation">
    <li class="active disabled"><a name="limit">Per Page</a></li>
    <% for(int lim: limits) { %>
    <li<% if(lim==limit) { %> class="active disabled"<% } %>><a name="<%= lim %>" class="limit" href="/jsp/getLogs.jsp<%= queryString %>&page=<%= pagenum %>&limit=<%= lim %>"><%= lim %></a></li>
    <% } %>
</ul>

<!-- ---------- AUTOREFRESH SECTION ---------- -->
<ul id="autoRefreshNavigation">
    <li class="active disabled"><a name="refresh">Auto-Refresh</a></li>
    <li><button name="1" id = "autorefreshbutton" class="btn btn-large autorefresh<% if (autorefresh) { %><%= " active btn-danger"  %><% } else { %><%= " btn-success" %><% } %>" data-toggle="button"><% if(autorefresh) { %><%= "Stop" %><% } else { %><%= "Start" %><% } %></button></li>
</ul>

<ul>
    <li class="disabled"><a id="loadingLogTableSpinnerIconDiv" href="#" style="visibility: hidden;"><img src="/hal/commands/getFile/web/icons/ajax-loader.gif"/></a></li>
</ul>
</div>

<div id="logsData">
<% if (logs.size() < 1) { %>
<p> No Log Records Exist</p>
<%  
} else {
%>

<div class="row">
<div class="span<%= hostCols %>"><strong>Host</strong></div>
<div class="span<%= levelCols %>"><strong>Level</strong></div>
<div class="span<%= timeCols %>"><strong>Time</strong></div>
<div class="span<%= messageCols %>"><strong>Message/Thrown</strong></div>
</div>
<hr>
<%

    for(Pair p: logs) {
           String host = (String)p.first();
           LogRecord logRecord = (LogRecord)p.second();
           Object[] params = logRecord.getParameters();
    
           //for(int i=0; i< params.length; i++) {
%>
        <div class="row">
            <div class="span<%= hostCols %>"><%= host %></div>
            
            <%  if(logRecord.getLevel()==Level.SEVERE) { %>
            <div class="span<%= levelCols %>"><span class="label label-important"><%= logRecord.getLevel() %></span></div>
            <% } else if (logRecord.getLevel()==Level.WARNING) { %>
            <div class="span<%= levelCols %>"><span class="label label-warning"><%= logRecord.getLevel() %></span></div>
            <% } else { %>
            <div class="span<%= levelCols %>"><span class="label label-info"><%= logRecord.getLevel() %></span></div>
            <% } %>
            
            <div class="span<%= timeCols %>"><%=dateOutput.format(new Date(logRecord.getMillis())) %></div>
            
            <div class="span<%= messageCols %>"><% if (logRecord.getThrown() != null) {
                java.io.StringWriter sw = new java.io.StringWriter();
                java.io.PrintWriter pw = new java.io.PrintWriter(sw);
                logRecord.getThrown().printStackTrace(pw);
                
               %>
                <%= sw.toString() %>
               <% } else { %>
                <%= logRecord.getMessage() %>
               <% } %>
             </div>
        </div>
            
<%
           //}
    } // end for
%>

</div> <!--  end #logsData -->
<% 
} // end if
%>

</div><!--  end #logsTable -->