$(document).ready(function(){
	
	var timeFormatString = "YYYY-MM-DD HH:mm";
	var today = new Date();
	var yesterday = new Date()
	yesterday.setDate(today.getDate()-1);
	
	var formatDateToString = function(date) {
		var string = '';
		string = string + date.getFullYear();
		string = string + '-';
		
		if (date.getMonth()+1 < 10) { string = string + '0' + (date.getMonth()+1); }
		else { string = string + (date.getMonth()+1); }
		
		string = string + '-';
		string = string + date.getDate();
		string = string + ' ';
		string = string + date.getHours();
		string = string + ':';
		string = string + date.getMinutes();
		//string = string + ':';
		//string = string + date.getSeconds();
		
		return string;
	}
	
	var beforeString = formatDateToString(yesterday);
	
	var afterString = formatDateToString(today);
	
	// hide/show input text fields depending on whether
	// we need those input boxes
	// ~ James' suggestion.
	
	$('#filterByTimeSelector').change(function() {
		if ($(this).val() == "int") {
			$('#filterByTimeBetweenInput').show();
		} else {
			$('#filterByTimeBetweenInput').hide();
		}
	});
	
	// show the format that we want the timestamp to be in
	
	$('#filterByTimeBefore')
	.val(beforeString)
	.change(function() {
		if ($(this).val() == '') {
			$(this).val(beforeString);
		}
	})
//	.focus(function() {
//		if ($(this).val() == timeFormatString) {
//			$(this).val('');
//		}
//	});
	
	$('#filterByTimeAfter')
	.val(afterString)
	.change(function() {
		if ($(this).val() == '') {
			$(this).val(afterString);
		}
	})
//	.focus(function() {
//		if ($(this).val() == timeFormatString) {
//			$(this).val('');
//		}
//	});
	
	function ajaxLogsTable(fURL) {
		$('#loadingLogTableSpinnerIconDiv').css('visibility','visible');

		
		ajaxInProgress = true;
		
		
		jqXHR = $.ajax({
			//data: { 'page': curPage, 'limit': limit },
			url: fURL,
			dataType: 'html',
			success: function(data) {
				setTimeout(function() {
					$('#loadingLogTableSpinnerIconDiv').css('visibility','hidden');
				},500);
				
				displayAndLinkData(data);
				ajaxInProgress = false;
				timeoutLength = 1000;
			}
		});
	}
	
	function displayAndLinkData(data) {
		//$('#logDiv').html(data);
		
		if (document.getElementById('logData')) {
			$('#pageNavigation').html($(data).find('#pageNavigation').html());
			$('#limitNavigation').html($(data).find('#limitNavigation').html());
			$('#autoRefreshNavigation').html($(data).find('#autoRefreshNavigation').html());
			$('#logsData').html($(data).find('#logsData').html());
		} else {
			$('#logDiv').html(data);
		}
		
		$('a.log').click(function() {
			if ($(this).parent().hasClass("disabled")) return false;
			fetchURL = $(this).attr('href');
			ajaxLogsTable(fetchURL);
			return false;
		});
		
		$('a.limit').click(function() {
			if ($(this).parent().hasClass("disabled")) return false;
			fetchURL = $(this).attr('href');
			ajaxLogsTable(fetchURL);
			return false;
		});
		
		$('button.autorefresh').click(function() {
			if($(this).hasClass('active')) {
				$(this)
					.removeClass('active')
					.addClass('btn-danger')
					.html('Stop');
			} else {
				$(this)
					.addClass('active')
					.addClass('btn-success')
					.html('Start');
			}
			doRefreshing();
		});
	}
	
	function doRefreshing() {
		var shouldAutoRefresh = $('#autorefreshbutton').hasClass("active");
		if (shouldAutoRefresh) {
			refreshing(shouldAutoRefresh);
		} else {
			clearTimeout(timer);
			var href=$('#firstPageLink').attr('href')+"&autorefresh=false";
			ajaxLogsTable(href);	
		}
	}
	
	function refreshing(autorefresh) {
		var href = $('#firstPageLink').attr('href')+"&autorefresh="+autorefresh;
		
		if (!ajaxInProgress) {
			// timeoutLength will be reset to its default 1000 after the ajax
			// call is successful
			ajaxLogsTable(href);
			timer = setTimeout(refreshing, timeoutLength, autorefresh);
		} else if (ajaxInProgress && (numTimeouts < 3)) { numTimeouts++; }
		else if (numTimeouts >=3) {
			jqXHR.abort();
			numTimeouts = 0;
			timeoutLength = timeoutLength*2;
			ajaxLogsTable(href);
			timer = setTimeout(refreshing,timeoutLength,autorefresh);
		}
		
	}
	
	var filterByLevelForm = $('#filterByLevelForm');
	var filterByTimeForm = $('#filterByTimeForm');
	var filterByHostnameForm = $('#filterByHostnameForm');
	
	var curPage = 1;
	var limit = 10;
	var fetchURL = "/jsp/getLogs.jsp";
	
	var ajaxInProgress = false;
	var numTimeouts = 0;
	var timeoutLength = 1000;
	var jqXHR;
	
	
	//(".hidden").hide();
	
	$(".submitButton").click(function() {
		var form = $(this).closest("form");
		//alert(form.serialize());
		$.ajax({
			data: form.serialize(),
			url: "/jsp/getLogs.jsp",
			dataType: 'html',
			success: function(data) {
				displayAndLinkData(data);
			}
		});
		
		return false;
	});
	
	$('.dropdown-toggle').dropdown();
	
	$('#filterByLevelLink').click(function() {
		//$('#filterForm').children().remove();
		$('#filterForm').children().detach()
		//.remove()
		$('#filterForm').append(filterByLevelForm.show());
	});
	
	$('#filterByTimeLink').click(function() {
		$('#filterForm').children().detach()
		//.remove();
		$('#filterForm').append(filterByTimeForm.show());
	});
	
	$('#filterByHostnameLink').click(function() {
		$('#filterForm').children().detach()
		//.remove();
		$('#filterForm').append(filterByHostnameForm.show());
	});
	
	//$.ajax({
	//	data: {page: 1, limit: 10},
	//	url: "/jsp/getLogs.jsp",
	//	dataType: 'html',
	//	success: function(data) {
	//		$('#logDiv').html(data);
	//	}
	//});
	
	ajaxLogsTable(fetchURL);
	
});