$(document).ready(function () {
	// create a class var to hold whether we should poll
	
	var runStatusPolling = function() {
		var should_poll = true;
		
		return {
			should_poll: function() {
				return should_poll;
			},
			// setter function
			can_poll: function(is_polling) {
				should_poll = is_polling;
			}
		};
	}();
	
	// this is prettycollapse dependent code that we do not
	// want to use anymore.
	// all click handler code is now in HAL.menu
	
	// ------- DEPRECATED -------
    //setupCollapsible('halRunStatusRunning');
    //setupCollapsible('halRunStatusReadyToLaunch');
    //setupCollapsible('halRunStatusQueued');
    //setupCollapsible('halRunStatusFinished');
    //setupCollapsible('halRunStatusTerminatedByUser');
    //setupCollapsible('halRunStatusTerminatedAbnormally');
    var statusObjects = {};
    statusObjects['running'] = {};
    statusObjects['readyToLaunch'] = {};
    statusObjects['queued'] = {};
    statusObjects['finished'] = {};
    statusObjects['terminatedByUser'] = {};
    statusObjects['terminatedAbnormally'] = {};

    function refreshCurrentRunStatus() {	
		// enter critical section
		var jq = $.post('/hal/getFormSnippet/runStatusMonitoring/currentRunStatus', 
			{ 'hal_httpResponseContentType': 'json'}, 
			function (jsonResponse) {
				var idList = jsonResponse['idList'];
				var newStatusObjects = {};
				newStatusObjects['running'] = {};
				newStatusObjects['readyToLaunch'] = {};
				newStatusObjects['queued'] = {};
				newStatusObjects['finished'] = {};
				newStatusObjects['terminatedByUser'] = {};
				newStatusObjects['terminatedAbnormally'] = {};
				for (var idIndex in idList) {
					var statusObj = jsonResponse['runStatus_' + idList[idIndex]];
					newStatusObjects[statusObj.status][idList[idIndex]] = statusObj;
				}
				for (var statusType in statusObjects) {
					for (var id in statusObjects[statusType]) {
						if (newStatusObjects[statusType][id] === undefined) {
							$('#halRunStatus_' + id).remove();
						}
					}
				}
				for (var statusType in newStatusObjects) {
					for (var id in newStatusObjects[statusType]) {
						if (statusObjects[statusType][id] === undefined) {
							var contentDiv = $('#halRunStatusContent_' + statusType);
							var newIdNum = parseInt(id);
							var newId = 'halRunStatus_' + id;
							var newDiv = $('<div id="' + newId + '" class="runStatusDetails"></div>');
							initialiseRunStatus(newDiv, newStatusObjects[statusType][id]);
							var inserted = false;
							contentDiv.contents().each(function (index, obj) {
								if ($(this).attr('id') && $(this).attr('id').match(/halRunStatus_(?:readyToLaunch_)?([0-9]*)/)) {
									var oldIdNum = parseInt(RegExp.$1);
									if (!inserted && oldIdNum <= newIdNum) {
										$(obj).before(newDiv);
										inserted = true;
									}
								}
							});
							if (!inserted) {
								contentDiv.append(newDiv);
							}
						}
					}
				}
				$('#halNumRunsRunning').html(numberOfProperties(newStatusObjects['running']));
				$('#halNumRunsReadyToLaunch').html(numberOfProperties(newStatusObjects['readyToLaunch']));
				$('#halNumRunsQueued').html(numberOfProperties(newStatusObjects['queued']));
				$('#halNumRunsFinished').html(numberOfProperties(newStatusObjects['finished']));
				$('#halNumRunsTerminatedByUser').html(numberOfProperties(newStatusObjects['terminatedByUser']));
				$('#halNumRunsTerminatedAbnormally').html(numberOfProperties(newStatusObjects['terminatedAbnormally']));
				for (var statusType in newStatusObjects) {
					for (var id in newStatusObjects[statusType]) {
						updateRunStatus($('#halRunStatus_' + id), newStatusObjects[statusType][id]);
					}
				}
				statusObjects = newStatusObjects;
				
				// after finish updating everything, allow others to poll again
				runStatusPolling.can_poll(true);
			}, // end callback function
		'json'); // end $.post
		
		timeoutTracker.setJqHXR(jq);
    }; // end function refreshCurrentStatus
    
    //refreshCurrentRunStatus();
    
    var timeoutTracker = function() {
    	var timer;
    	var numTries = 0;
    	var timeoutLength = 1000;
    	var jqHXR;
    	
    	return {
    		getTimer: function() { return timer; },
    		setTimer: function(newTimer) { timer = newTimer; },
    		addTry: function() { numTries++; },
    		getTries: function() { return numTries; },
    		resetTries: function() { numTries = 0; },
    		getTimeoutLength: function() { return timeoutLength; },
    		doubleTimeoutLength: function() { timeoutLength = timeoutLength*2; },
    		resetTimeoutLength: function() { timeoutLength = 1000; },
    		setTimeoutLength: function(newTimeout) { 
    			if (newTimeout < 500 ) { timeoutLength = 500; }
    			else { timeoutLength = newTimeout; }
    		},
    		setJqHXR: function(newObject) { jqHXR = newObject; },
    		getJqHXR: function() { return jqHXR; }
    	}
    	
    }();
    
    
    function startTimeout() {
    	if (runStatusPolling.should_poll()) {
    		runStatusPolling.can_poll(false);
    		refreshCurrentRunStatus();
    		if (timeoutTracker.getTimeoutLength() <= 1000) { timeoutTracker.setTimeoutLength(timeoutTracker.getTimeoutLength()-100); }
    		timeoutTracker.setTimer(setTimeout(startTimeout, timeoutTracker.getTimeoutLength()));
    	} else if (timeoutTracker.getTries() < 3) {
    		timeoutTracker.addTry();
    		timeoutTracker.doubleTimeoutLength();
    		timeoutTracker.setTimer(setTimeout(startTimeout, timeoutTracker.getTimeoutLength()));
    	} else if (timeoutTracker.getTries() >= 3) {
    		timeoutTracker.getJqHXR().abort();
    		timeoutTracker.resetTries();
    		clearTimeout(timeoutTracker.getTimer());
    		timeoutTracker.resetTimeoutLength();
    		timeoutTracker.setTimer(setTimeout(startTimeout,timeoutTracker.getTimeoutLength()));
    	}
    }
    
    timeoutTracker.setTimer(setTimeout(startTimeout, 1 * 1000));
    
});