function createImportForm(options) {
	var uploadPortion = $('<div></div>');
	
	var importPortion = $('<div></div>');
	
	var uploadFinished = function(files) {
		uploadPortion.remove();
		
		createImport(
			{
				'target' : importPortion,
				'objectFile' : files[0]
			}
		);
	};
	
	createUploadFileForm(
		{
			'target' : uploadPortion,
			'showDestinationField' : false,
			'extractArchiveContents' : false,
			'callbackFunction' : uploadFinished
		}
	);

	options.target.append(uploadPortion);
	options.target.append(importPortion);
}

function createImport(options) {
	var spinnerImage = $('<img>');
	spinnerImage.attr('src', '/hal/commands/getFile/web/icons/ajax-loader.gif');
	spinnerImage.attr('value', 'Initialising import. Please wait.');
	
	var spinner = $('<div></div>');
	spinner.addClass('center');
	spinner.addClass('success');
	spinner.addClass('spinner');
	spinner.append(spinnerImage);
	
	options.target.append(spinner);
	
	$.post('/hal/processFormSnippet/importObjects/importFile',
		{
			'importHalObjects_objectFile' : options.objectFile,
			'importHalObjects_ignoreMissing' : 'on',
			'hal_httpResponseContentType' : 'json'
		},
		function(response) {
			if (response.successful) {
				options.target.html('');
				
				var progressBarContainer = $('<div></div>');
				progressBarContainer.addClass('formElement');
				
				var progressBarLabel = $('<label></label>');
				progressBarLabel.attr('for', 'import_progressBar');
				progressBarLabel.html('Import progress');
				
				var progressBar = $('<div></div>');
				progressBar.addClass('runProgressBar');
				
				var progressBarText = $('<div></div>');
				progressBarText.addClass('progressBarText');
				
				var progressBarOptions = {
						steps : 100,
						width : 120,
						showText : false,
						boxImage : '/hal/commands/getFile/web/icons/progressbar.gif',
						barImage : '/hal/commands/getFile/web/icons/progressbg_halBlue.gif'
				};
				
				progressBar.progressBar(progressBarOptions);
				
				progressBarContainer.append(progressBarLabel);
				progressBarContainer.append(progressBar);
				progressBarContainer.append(progressBarText);
				progressBarContainer.append($('<div></div>').addClass('clear'));
				
				var importedObjectsName = $('<span></span>');
				importedObjectsName.append("List of HAL objects imported");
				
				var importedObjectsNameLink = $('<a></a>');
				importedObjectsNameLink.append(importedObjectsName);
				
				var importedObjectsHeader = $('<div></div>');
				importedObjectsHeader.addClass('collapsed');
				importedObjectsHeader.append(importedObjectsNameLink);
				
				var importedObjectsContent = $('<div></div>');
				importedObjectsContent.addClass('collapsibleContent');
				
				var importedObjectsContainer = $('<div></div>');
				importedObjectsContainer.addClass('collapsible');
				importedObjectsContainer.append(importedObjectsHeader);
				importedObjectsContainer.append(importedObjectsContent);
				importedObjectsContainer.hide();
				
				var importProgressLogName = $('<span></span>');
				importProgressLogName.append("Import log");
				
				var importProgressLogNameLink = $('<a></a>');
				importProgressLogNameLink.append(importProgressLogName);
				
				var importProgressLogHeader = $('<div></div>');
				importProgressLogHeader.addClass('collapsed');
				importProgressLogHeader.append(importProgressLogNameLink);
				
				var importProgressLogContent = $('<div></div>');
				importProgressLogContent.addClass('collapsibleContent');
				
				var importProgressLogContainer = $('<div></div>');
				importProgressLogContainer.addClass('collapsible');
				
				importProgressLogContainer.append(importProgressLogHeader);
				importProgressLogContainer.append(importProgressLogContent);
				
				collapsible(importedObjectsContainer);
				collapsible(importProgressLogContainer);
				
				var importMessages = $('<div></div>');
				importMessages.hide();
				
				var importAnotherFileButton = $('<input></input>');
				importAnotherFileButton.attr('type', 'button');
				importAnotherFileButton.attr('value', 'Import another file');
				importAnotherFileButton.click(function(){
					window.location.href = '/hal/importObjects';
				});
				importAnotherFileButton.hide();
				
				var cancelButton = $('<input></input>');
				cancelButton.attr('type', 'button');
				cancelButton.attr('value', 'Cancel');
				cancelButton.click(cancelForm);
				
				var returnToHalButton = $('<input></input>');
				returnToHalButton.attr('type', 'button');
				returnToHalButton.attr('value', 'Return to HAL');
				returnToHalButton.click(cancelForm);
				returnToHalButton.hide();
				
				var importButtonsContainer = $('<div></div>');
				importButtonsContainer.addClass('center');
				
				importButtonsContainer.append(importAnotherFileButton);
				importButtonsContainer.append(cancelButton);
				importButtonsContainer.append(returnToHalButton);
				
				var progressContainer = $('<div></div>');
				progressContainer.addClass('success');
				
				progressContainer.append(progressBarContainer);
				progressContainer.append(importedObjectsContainer);
				progressContainer.append(importProgressLogContainer);
				
				options.target.append(progressContainer);
				options.target.append(importMessages);
				options.target.append('<hr>');
				options.target.append(importButtonsContainer);
				
				var importTimer;
				
				var checkImportProgress = function() {
					$.post('/hal/processFormSnippet/importObjects/getImportProgress',
						{
							'importId' : response.importId,
							'hal_httpResponseContentType' : 'json'
						},
						function(progressResponse) {
							if (progressResponse.successful) {
								progressBar.progressBar(progressResponse.percentComplete);
								progressBarText.html(progressResponse.percentComplete.toFixed(3)+'%');
								
								importProgressLogContent.html(progressResponse.importLog);
								
								if (progressResponse.wasError) {
									importMessages.removeClass('success').removeClass('error').addClass('alert');
									importMessages.html('');
									
									if (progressResponse.wasWarning) {
										importMessages.append('<div>WARNING: Some warnings occurred during import. For details please see the log.</div>');
									}
									importMessages.append('<div>ERROR: Some objects could not be imported. For details please see the log.</div>');
									importMessages.show();
								} else if (progressResponse.wasWarning) {
									importMessages.removeClass('success').removeClass('alert').addClass('error');
									importMessages.html('');
									importMessages.append('<div>WARNING: Some warnings occurred during import. For details please see the log.</div>');
									importMessages.show();
								}
								
								if (progressResponse.completed && !progressResponse.alreadyCompleted) {
									clearInterval(importTimer);
									
									if (progressResponse.hasImportedObjects) {
										importedObjectsContent.html(progressResponse.importedObjects);
										importedObjectsContainer.slideDown();
									}
									
									// Deal with the buttons.
									importAnotherFileButton.show();
									cancelButton.hide();
									returnToHalButton.show();
									
									$.post('hal/progressFormSnippet/importObjects/removeActiveImport',
										{
											'importId' : response.importId
										}
									);
								}
							} else {
								clearInterval(importTimer);
								importMessages.removeClass('success').addClass('error');
								importMessages.html(progressResponse.errorMessage);
								importMessages.show();
							}
						},
						'json'
					);
				};
				
				importTimer = setInterval(checkImportProgress, 1000);
			} else {
				options.target.removeClass('success').addClass('error');
				options.target.html(response.errorMessage);
			}
		},
		'json'
	);
}