function createInstanceSetForm(options) {
	var newInstanceSetForm = $('<form></form>');
	newInstanceSetForm.attr('id', 'newInstanceSet');
	
	var propertiesSectionHeaderText = $('<span></span>').html('Instance set information');
	var propertiesSectionContent = $('<div></div>');
	var propertiesSectionContainer = $('<div></div>');
	
	createCollapsibleMenu({
		'headerContent' : propertiesSectionHeaderText,
		'contentContainer' : propertiesSectionContent,
		'menuContainer' : propertiesSectionContainer,
		'initialState' : 'expanded'
	});
	
	newInstanceSetForm.append(propertiesSectionContainer);
	
	var nameLabel = $('<label></label>');
	nameLabel.attr('for', 'newInstanceSet_name');
	nameLabel.html('Instance set name');
	
	var nameField = $('<input></input>');
	nameField.attr('type', 'text');
	nameField.attr('size', 50);
	nameField.attr('name', 'newInstanceSet_name');
	nameField.attr('id', 'newInstanceSet_name');
	
	var nameContainer = $('<div></div>');
	nameContainer.addClass('formElement');
	nameContainer.append(nameLabel);
	nameContainer.append(nameField);
	
	propertiesSectionContent.append(nameContainer);
	
	var descriptionLabel = $('<label></label>');
	descriptionLabel.attr('for', 'newInstanceSet_description');
	descriptionLabel.html('Instance set description (optional)');
	
	var descriptionField = $('<textarea></textarea>');
	descriptionField.attr('id', 'newInstanceSet_description');
	descriptionField.attr('name', 'newInstanceSet_description');
	descriptionField.attr('cols', 75);
	descriptionField.attr('rows', 6);
	
	var descriptionContainer = $('<div></div>');
	descriptionContainer.addClass('formElement');
	descriptionContainer.append(descriptionLabel);
	descriptionContainer.append(descriptionField);
	
	propertiesSectionContent.append(descriptionContainer);
	
	var advancedInformationHeaderText = $('<span></span>').html('Advanced');
	var advancedInformationContent = $('<div></div>');
	var advancedInformationContainer = $('<div></div>');
	
	var helpLink = $('<a></a>').html('&nbsp;?&nbsp;')
	.css('background-color','#3A87AD').css('color','white')
	.click(function() {
			window.open('/jsp/HelpPage.jsp#exportableInstances') } );
	
	createCollapsibleMenu({
		'headerContent' : advancedInformationHeaderText,
		extraHeaderContent : [helpLink],
		'contentContainer' : advancedInformationContent,
		'menuContainer' : advancedInformationContainer,
		'initialState' : 'collapsed'
	});
	
	propertiesSectionContent.append(advancedInformationContainer);
	
	var exportableLabel = $('<label></label>');
	exportableLabel.attr('for', 'newInstanceSet_isExportable');
	exportableLabel.html('Is your instance set exportable?');
	
	var exportableCheckbox = $('<input></input>');
	exportableCheckbox.attr('id', 'newInstanceSet_isExportable');
	exportableCheckbox.attr('name', 'newInstanceSet_isExportable');
	exportableCheckbox.attr('type', 'checkbox');
	
	var exportableElement = $('<div></div>');
	exportableElement.addClass('formElementInline');
	exportableElement.append(exportableLabel);
	exportableElement.append(exportableCheckbox);
	
	advancedInformationContent.append(exportableElement);
	
	var tagSetsHeaderText = $('<span></span>').html('Tag sets');
	var tagSetsContent = $('<div></div>');
	var tagSetsContainer = $('<div></div>');
	
	createCollapsibleMenu({
		'headerContent' : tagSetsHeaderText,
		'contentContainer' : tagSetsContent,
		'menuContainer' : tagSetsContainer,
		'initialState' : 'collapsed'
	});
	
	createMultipleTagSetSelector({
		'target' : tagSetsContent,
		'idPrefix' : 'newInstanceSet_',
		'description' : 'Please specify each of the sets of tags satisfied by this instance set. Each tag set should be a comma-separated list of tags, and you may use the drop-down selector to insert tags that are already defined in HAL.'
	});
	
	propertiesSectionContent.append(tagSetsContainer);
	
	var instanceSpecificationHeaderText = $('<span></span>').html('Instance specification');
	var instanceSpecificationContent = $('<div></div>');
	var instanceSpecificationContainer = $('<div></div>');
	
	createCollapsibleMenu({
		'headerContent' : instanceSpecificationHeaderText,
		'contentContainer' : instanceSpecificationContent,
		'menuContainer' : instanceSpecificationContainer,
		'initialState' : 'expanded'
	});
	
	newInstanceSetForm.append(instanceSpecificationContainer);
	
	var fileSpecificationHeaderText = $('<span></span>').html('Instance file specification');
	var fileSpecificationContent = $('<div></div>');
	var fileSpecificationContainer = $('<div></div>');
	
	createCollapsibleMenu({
		'headerContent' : fileSpecificationHeaderText,
		'contentContainer' : fileSpecificationContent,
		'menuContainer' : fileSpecificationContainer,
		'initialState' : 'expanded'
	});
	
	instanceSpecificationContent.append(fileSpecificationContainer);
	
	var directoryPathLabel = $('<label></label>');
	directoryPathLabel.attr('for', 'newInstanceSet_directoryPath');
	directoryPathLabel.html('Path to the directory containing the instance files');
	
	var directoryPathDescription = $('<div></div>');
	directoryPathDescription.addClass('formFieldDescription');
	directoryPathDescription.html('This is the path to a directory on the server filesystem containing the instance files for this set.');
	
	var directoryPathField = $('<input></input>');
	directoryPathField.attr('type', 'text');
	directoryPathField.attr('size', 100);
	directoryPathField.attr('id', 'newInstanceSet_directoryPath');
	directoryPathField.attr('name', 'newInstanceSet_directoryPath');
	
	var directoryPathContainer = $('<div><div>');
	directoryPathContainer.addClass('formElement');
	directoryPathContainer.append(directoryPathLabel);
	directoryPathContainer.append(directoryPathDescription);
	directoryPathContainer.append(directoryPathField);
	
	fileSpecificationContent.append(directoryPathContainer);
	
	var descendIntoSubdirectoriesLabel = $('<label></label>');
	descendIntoSubdirectoriesLabel.attr('for', 'newInstanceSet_descendIntoSubdirectories');
	descendIntoSubdirectoriesLabel.html('Descend into subdirectories?');
	
	var descendIntoSubdirectoriesCheckbox = $('<input></input>');
	descendIntoSubdirectoriesCheckbox.attr('type', 'checkbox');
	descendIntoSubdirectoriesCheckbox.attr('id', 'newInstanceSet_descendIntoSubdirectories');
	descendIntoSubdirectoriesCheckbox.attr('name', 'newInstanceSet_descendIntoSubdirectories');
	descendIntoSubdirectoriesCheckbox.attr('checked', 'on');
	
	var descendIntoSubdirectoriesContainer = $('<div></div>');
	descendIntoSubdirectoriesContainer.addClass('formElementInline');
	descendIntoSubdirectoriesContainer.append(descendIntoSubdirectoriesLabel);
	descendIntoSubdirectoriesContainer.append(descendIntoSubdirectoriesCheckbox);
	
	fileSpecificationContent.append(descendIntoSubdirectoriesContainer);
	
	var fileFilteringHeaderText = $('<span></span>').html('File selection and filtering');
	var fileFilteringContent = $('<div></div>');
	var fileFilteringContainer = $('<div></div>');
	
	createCollapsibleMenu({
		'headerContent' : fileFilteringHeaderText,
		'contentContainer' : fileFilteringContent,
		'menuContainer' : fileFilteringContainer,
		'initialState' : 'collapsed'
	});
	
	disableMenu(fileFilteringContainer);
	instanceSpecificationContent.append(fileFilteringContainer);
	
	var filtersHeaderText = $('<span></span>').html('File filters');
	var filtersContent = $('<div></div>');
	var filtersContainer = $('<div></div>');
	
	createCollapsibleMenu({
		'headerContent' : filtersHeaderText,
		'contentContainer' : filtersContent,
		'menuContainer' : filtersContainer,
		'initialState' : 'expanded'
	});
	
	fileFilteringContent.append(filtersContainer);
	
	var fileListHeaderText = $('<span></span>');
	var fileListContent = $('<div></div>');
	var fileListContainer = $('<div></div>');
	
	createCollapsibleMenu({
		'headerContent' : fileListHeaderText,
		'contentContainer' : fileListContent,
		'menuContainer' : fileListContainer,
		'initialState' : 'collapsed'
	});
	
	fileFilteringContent.append(fileListContainer);
	
	var filterFiles = function(options) {
		newInstanceSetStatusMessages.hide();
		
		var formData = newInstanceSetForm.serialize();
		formData = formData+'&hal_httpContentResponse=json';
		formData = formData+'&validateOnly=true';
		
		$.post('/hal/getFormSnippet/createInstanceSet/createInstanceSet',
				formData,
				function(response) {
					if (response.successful) {
						fileListHeaderText.html(numberOfProperties(response.matchedFiles)+' files matched.');
						fileListContent.html('');
						fileListContent.append('<ul>');
						for (var i in response.matchedFiles) {
							fileListContent.append('<li>'+response.matchedFiles[i]+'</li>');
						}
						fileListContent.append('</ul>');
					} else {
						newInstanceSetStatusMessages.removeClass('success').addClass('error');
						newInstanceSetStatusMessages.html(response.errorMessage);
						newInstanceSetStatusMessages.show();
					}
				},
				'json'
		);
	}
	
	createMultipleStringFilterSelector({
		'description' : 'Each filter is a regular expression used to match files in the chosen directory. Any files that are not matched by all filters will be ignored. For example, using the filter ".*\.cnf" will match all files with a .cnf extension.',
		'idPrefix' : 'newInstanceSet_',
		'target' : filtersContent,
		'showFilterButton' : true,
		'onFilter' : filterFiles
	});
	
	var reenableInputButton = $('<input></input>');
	reenableInputButton.attr('type', 'button');
	reenableInputButton.attr('value', 'Re-enable input');
	reenableInputButton.click(function() {
		enableMenu(propertiesSectionContainer);
		expandMenu(propertiesSectionContainer);
		
		enableMenu(fileSpecificationContainer);
		expandMenu(fileSpecificationContainer);
		
		disableMenu(fileFilteringContainer);
		collapseMenu(fileFilteringContainer);
		
		reenableInputButton.hide();
		submitButton.hide();
		validateButton.show();
	});
	reenableInputButton.hide();
	
	var submitButton = $('<input></input>');
	submitButton.attr('type', 'button');
	submitButton.attr('value', 'Submit');
	submitButton.click(function() {
		submitButton.attr('disabled', true);
		reenableInputButton.attr('disabled', true);
		newInstanceSetStatusMessages.hide();
		
		var formData = newInstanceSetForm.serialize();
		formData = formData+'&hal_httpContentResponse=json';
		formData = formData+'&validateOnly=false';
		
		$.post('/hal/getFormSnippet/createInstanceSet/createInstanceSet',
			formData,
			function(response) {
				submitButton.attr('disabled', false);
				reenableInputButton.attr('disabled', false);
				
				if (response.successful) {
					submitButton.hide();
					reenableInputButton.hide();
					cancelButton.hide();
					
					addFeaturesButton.show();
					returnToHalButton.show();
					
					newInstanceSetStatusMessages.removeClass('error').removeClass('alert').addClass('success');
					newInstanceSetStatusMessages.html('Instance set was defined successfully.');
					newInstanceSetStatusMessages.show();
				} else {
					newInstanceSetStatusMessages.removeClass('success').addClass('error');
					newInstanceSetStatusMessages.html(response.errorMessage);
					newInstanceSetStatusMessages.show();
				}
			},
			'json'
		);
	});
	submitButton.hide();
	
	var validateButton = $('<input></input>').attr('type', 'button').attr('value', 'Next').attr('id','instanceFilesNextButton')
	.click(function() {
		validateButton.attr('disabled', true);
		newInstanceSetStatusMessages.hide();
		
		var formData = newInstanceSetForm.serialize();
		formData = formData+'&hal_httpContentResponse=json';
		formData = formData+'&validateOnly=true';
		
		$.post('/hal/getFormSnippet/createInstanceSet/createInstanceSet',
				formData,
				function(response) {
					validateButton.attr('disabled', false);
			
					if (response.successful) {
						disableMenu(propertiesSectionContainer);
						collapseMenu(propertiesSectionContainer);

						disableMenu(fileSpecificationContainer);
						collapseMenu(fileSpecificationContainer);
						
						enableMenu(fileFilteringContainer);
						expandMenu(fileFilteringContainer);
						
						validateButton.hide();
						reenableInputButton.show();
						submitButton.show();
						
						fileListHeaderText.html(numberOfProperties(response.matchedFiles)+' files matched.');
						fileListContent.html('');
						fileListContent.append('<ul>');
						for (var i in response.matchedFiles) {
							
							fileListContent.append('<li>'+response.matchedFiles[i]+'</li>');
						}
						fileListContent.append('</ul>');
					} else {
						newInstanceSetStatusMessages.removeClass('success').addClass('error');
						newInstanceSetStatusMessages.html(response.errorMessage);
						newInstanceSetStatusMessages.show();
					}
				},
				'json'
		);
	});
	
	var addFeaturesButton = $('<input></input>');
	addFeaturesButton.attr('type', 'button');
	addFeaturesButton.attr('value', 'Add features');
	addFeaturesButton.click(function() {
		
	});
	addFeaturesButton.hide();
	
	var returnToHalButton = $('<input></input>');
	returnToHalButton.attr('type', 'button');
	returnToHalButton.attr('value', 'Return to HAL');
	returnToHalButton.click(function() {
		window.location.href = '/hal/';
	});
	returnToHalButton.hide();
	
	var cancelButton = $('<input></input>');
	cancelButton.attr('type', 'button');
	cancelButton.attr('value', 'Cancel');
	cancelButton.click(cancelForm);
	
	var instanceSpecificationButtons = $('<div></div>');
	instanceSpecificationButtons.addClass('center');
	instanceSpecificationButtons.append(validateButton);
	instanceSpecificationButtons.append(reenableInputButton);
	instanceSpecificationButtons.append(submitButton);
	instanceSpecificationButtons.append(addFeaturesButton);
	instanceSpecificationButtons.append(returnToHalButton);
	instanceSpecificationButtons.append(cancelButton);
	
	instanceSpecificationContent.append('<hr>');
	
	instanceSpecificationContent.append(instanceSpecificationButtons);
	
	var newInstanceSetStatusMessages = $('<div></div>');
	
	options.target.append(newInstanceSetForm);
	options.target.append(newInstanceSetStatusMessages);
}

function createInstanceDistributionSelector(options) {
	$.post('/hal/getFormSnippet/utilities/getDefinedInstanceSets',
		{
			'hal_httpResponseContentType' : 'json'
		},
		function(response) {
			if (response.successful) {
				var setNames = response.result.instanceSets
				
				options.target.html('');
				
				var defaultOpt = $('<option></option>');
				defaultOpt.attr('value', '');
				defaultOpt.html('--- Choose an instance distribution ---');
				options.target.append(defaultOpt);
				
				for (var i in setNames) {
					var opt = $('<option></option>');
					opt.attr('value', setNames[i]);
					opt.html(setNames[i]);
					
					options.target.append(opt);
				}
			}
			
			options.onFinished({
				'successful' : response.successful
			});
		},
		'json'
	);
}

HAL.instanceDistributionSelector = function(options) {
	if ( !(this instanceof HAL.instanceDistributionSelector) ) {
	      return new HAL.instanceDistributionSelector(options);
	}
	
	var initialValue = options.initialValue;
	
	var _instanceDistributionLabel = $('<label></label>');
	_instanceDistributionLabel.attr('for', options.idPrefix+'_instanceDistributionName');
	_instanceDistributionLabel.html('Instance distribution');
	
	var _instanceDistributionField = $('<select></select>');
	_instanceDistributionField.attr('name', options.idPrefix+'_instanceDistributionName');
	_instanceDistributionField.attr('id', options.idPrefix+'_instanceDistributionName');
	_instanceDistributionField.append($('<option></option>').attr('value', '').html('Populating...'));
	
	var _instanceDistributionContainer = $('<div></div>');
	_instanceDistributionContainer.addClass('formElement');
	if (options.showLabel == null || options.showLabel) {
		_instanceDistributionContainer.append(_instanceDistributionLabel);
	}
	_instanceDistributionContainer.append(_instanceDistributionField);
	
	var _changeCallbacks = [];
	_instanceDistributionField.change(function() {
		for (var i in _changeCallbacks) {
			_changeCallbacks[i]();
		}
	});
	
	$.post('/hal/getFormSnippet/utilities/getDefinedInstanceSets',
		{
			'hal_httpResponseContentType' : 'json'
		},
		function(response) {
			if (response.successful) {
				var instanceDistributionNames = response.result.instanceSets;
				_instanceDistributionField.empty();

				var defaultOpt = $('<option></option>');
				defaultOpt.attr('value', '');
				
				if (numberOfProperties(instanceDistributionNames) !== 0) {
					defaultOpt.html('--- Choose an instance distribution ---');
				} else {
					defaultOpt.html('--- No instance distributions defined! ---');
				}
				_instanceDistributionField.append(defaultOpt);

				for (var i in instanceDistributionNames) {
					var opt = $('<option></option>');
					
					if (initialValue && initialValue == instanceDistributionNames[i]) {
						isValidValue = true;
					}
					
					opt.attr('value', instanceDistributionNames[i]);
					opt.html(instanceDistributionNames[i]);

					_instanceDistributionField.append(opt);
				}
				
				if (initialValue) {
					_instanceDistributionField.children().each(function(index,item) {
						if ($(item).val()==initialValue) {
							_instanceDistributionField.val(initialValue);
						}
					});
				}
			}
		},
		'json'
	);
	
	return {
		getElement : function() {
			return _instanceDistributionContainer;
		},
		addChangeCallback : function(callback) {
			_changeCallbacks.push(callback);
		},
		getValue : function() {
			return _instanceDistributionField.val();
		},
		clear : function() {
			_instanceDistributionField.val('');
			return this;
		},
		setValue : function(value) {
			_instanceDistributionField.children().each(function(index,item) {
				if ($(item).val()==value) { _instanceDistributionField.val(value); }
			});
			
			return this;
		}
	};
}