function createParameterSpaceInput(options) {
	var space = options.parameterSpace;
	
	// target is encompassing div. Each entry in the space is a div containing two other divs
	options.target.html('');
	
	for (var i in space) {
		var container = $('<div></div>');
		container.addClass('formElement');
		createDomainInputField({
			'target' : container,
			'label' : space[i].description,
			'domain' : space[i].domain,
			'fillWithDefaults' : options.fillWithDefaults,
			'idPrefix' : options.idPrefix+'_'+i
		});
		
		options.target.append(container);
	}
}

HAL.parameterSettingsField = function(options) {
	if ( !(this instanceof HAL.parameterSettingsField) ) {
	      return new HAL.parameterSettingsField(options);
	}
	
	var _idPrefix = options.idPrefix == null ? 'noid' : options.idPrefix;
	var _parameterSpace = options.parameterSpace;
	
	var _fields = {};
	
	var _container = $('<div></div>');

	var _refresh = function() {
		_container.empty();
		
		var oldFields = _fields;
		_fields = {};
		
		for (var i in _parameterSpace) {
			var oldElement = oldFields[i];
			var oldValue = null;
			if (oldElement !== undefined && oldElement !== null) {
				var oldValue = oldElement.getValue();
			}
			
			var field = new HAL.domainInput({
				idPrefix : _idPrefix+'_'+i,
				description : _parameterSpace[i].description,
				domain : _parameterSpace[i].domain,
				fillWithDefaults : options.fillWithDefaults
			});
			
			if (oldValue !== null && oldValue !== undefined) {
				field.setValue(oldValue);
			}
			_fields[i] = field;
			_container.append(field.getElement());
		}
	};

	_refresh();
	
	return {
		getElement : function() {
			return _container;
		},
		getNumberOfParameters : function() {
			return numberOfProperties(_parameterSpace);
		},
		updateParameterSpace : function(newSpace) {
			_parameterSpace = newSpace;
			
			_refresh();
		}
	}
}